(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***   Sample application (DLL tutorial                                     ***
 ***   Version [----]                               {Last mod 2003-10-05}   ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 ******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***                Copyright (c) 1995 - 2003 by -=Assarbad=-               ***
 ***                                                                        ***
 ***   CONTACT TO THE AUTHOR(S):                                            ***
 ***    ____________________________________                                ***
 ***   |                                    |                               ***
 ***   | -=Assarbad=- aka Oliver            |                               ***
 ***   |____________________________________|                               ***
 ***   |                                    |                               ***
 ***   | Assarbad@gmx.info|.net|.com|.de    |                               ***
 ***   | ICQ: 281645                        |                               ***
 ***   | AIM: nixlosheute                   |                               ***
 ***   |      nixahnungnicht                |                               ***
 ***   | MSN: Assarbad@ePost.de             |                               ***
 ***   | YIM: sherlock_holmes_and_dr_watson |                               ***
 ***   |____________________________________|                               ***
 ***             ___                                                        ***
 ***            /   |                     ||              ||                ***
 ***           / _  |   ________ ___  ____||__    ___   __||                ***
 ***          / /_\ |  / __/ __//   |/  _/|   \  /   | /   |                ***
 ***         / ___  |__\\__\\  / /\ || |  | /\ \/ /\ |/ /\ | DOT NET        ***
 ***        /_/   \_/___/___/ /_____\|_|  |____/_____\\__/\|                ***
 ***       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        ***
 ***              [http://assarbad.net | http://assarbad.org]               ***
 ***                                                                        ***
 ***   Notes:                                                               ***
 ***   - my first name is Oliver, you may well use this in your e-mails     ***
 ***   - for questions and/or proposals drop me a mail or instant message   ***
 ***                                                                        ***
 ***~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                     Vsem Privet iz Germanij                            ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2003, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/

 ******************************************************************************)

program Sample;
uses
  Windows,
  Messages;

(*
  Diese Definition bestimmt, ob das Programm statisch oder dynamisch mit der DLL
  gelinkt wird.
  Wird die Definition entfernt (also das "$" gelscht), dann erfolgt die
  Einbindung dynamisch. Dies ist auch die Standardeinstellung.
*)

{$R .\main.res} // Ressourcen einbinden
{$INCLUDE .\Type.inc}
{$INCLUDE .\Include\Compilerswitches.pas} // Einige Compileroptionen setzen
{$INCLUDE .\Include\Constants.pas} // Konstanten einbinden (Dialog usw.)
{$INCLUDE .\Include\Common.pas} // Allgemeine Funktionen
{$INCLUDE .\Include\GetFont.pas} // Font erstellen und zurckgeben

var
  appIcon: HICON = 0;
  hDlg: HWND;

{$IFDEF STATIC}
{$INCLUDE .\Include\STATIC.pas}
{$ELSE}
{$INCLUDE .\Include\DYNAMIC.pas}
{$ENDIF STATIC}

function DlgFunc(hwnd: hwnd; umsg: Cardinal; wparam: wparam; lparam: lparam): bool; stdcall;
var
  font: HFONT;
begin
  Result := TRUE;
// Einzelnachrichten auswerten
  case umsg of
    WM_INITDIALOG:
      begin
// Icon setzen. Windows XP benutzt ICON_SMALL, alle anderen Versionen ICON_BIG
        SendMessage(hwnd, WM_SETICON, ICON_SMALL, appIcon);
        SendMessage(hwnd, WM_SETICON, ICON_BIG, appIcon);
// Fonthandle holen. Feste Breite (in diesem Fall "Courier New")
        font := GetFont(hwnd, 10, FW_NORMAL, true);
// Schriftarten der Textfelder setzen
        SendDlgItemMessage(hwnd, IDC_EDIT1, WM_SETFONT, font, LongInt(TRUE));
        SendDlgItemMessage(hwnd, IDC_EDIT2, WM_SETFONT, font, LongInt(TRUE));
        SendDlgItemMessage(hwnd, IDC_EDIT3, WM_SETFONT, font, LongInt(TRUE));
        SendDlgItemMessage(hwnd, IDC_EDIT7, WM_SETFONT, font, LongInt(TRUE));
        SendDlgItemMessage(hwnd, IDC_EDIT8, WM_SETFONT, font, LongInt(TRUE));
        SendDlgItemMessage(hwnd, IDC_EDIT9, WM_SETFONT, font, LongInt(TRUE));
        SendDlgItemMessage(hwnd, IDC_EDIT10, WM_SETFONT, font, LongInt(TRUE));
        SendDlgItemMessage(hwnd, IDC_EDIT14, WM_SETFONT, font, LongInt(TRUE));
        SendDlgItemMessage(hwnd, IDC_EDIT15, WM_SETFONT, font, LongInt(TRUE));
// Als erstes der DLL bescheidgeben, an welches Fenster Ausgaben erfolgen sollen
        InitDLL(hwnd);
// Global das Handle dieses Dialogs bekannt machen
        hDlg := hwnd;
// WM_INITDIALIG erfordert, wenn bearbeitet, da FALSE zurckgegeben wird
        Result := FALSE;
      end;
    WM_CLOSE:
// Dialog formal beenden. Ohne diesen Aufruf gehts nur noch mit DestroyWindow.
      EndDialog(hwnd, 0);
    WM_CTLCOLORSTATIC:
      begin
// Readonly-Textfelder werden als statische Elemente behandelt
// Control ID zum Handle herausfinden (Handle in lParam)
        case GetDlgCtrlID(lParam) of
// Die Parameter-Felder
          IDC_EDIT1,
            IDC_EDIT2,
            IDC_EDIT3,
            IDC_EDIT7,
            IDC_EDIT8,
            IDC_EDIT9,
            IDC_EDIT10,
            IDC_EDIT14:
            SetTextColor(wParam, RGB($77, 0, 0)); // leichtes Rot
// Das Textfeld welches den Namen der aufgerufenen Funktion anzeigt
          IDC_EDIT15:
            SetTextColor(wParam, RGB(0, $77, 0)); // leichtes Grn
// Alle anderen statischen Elemente.
        else
          SetTextColor(wParam, RGB(0, 0, $77)); // leichtes Blau
        end;
// Hintergrund undurchsichtig
        SetBkMode(wParam, OPAQUE);
// Hintergrundfarbe setzen
        SetBkColor(wParam, GetSysColor(COLOR_BTNFACE));
// Pinsel (Brush) setzen, mit welchem der Hintergrund gezeichnet wird
        result := BOOL(GetSysColorBrush(COLOR_BTNFACE));
      end;
    WM_COMMAND:
// Ereignistyp auswerten
      case HiWord(WParam) of
// Es fand ein Klickereignis statt
        BN_CLICKED:
// Control ID auswerten
          case LoWord(wParam) of
// Nachrichten an alle Buttons auswerten
            IDC_BUTTON1,
              IDC_BUTTON2,
              IDC_BUTTON3,
              IDC_BUTTON4,
              IDC_BUTTON5,
              IDC_BUTTON6,
              IDC_BUTTON7,
              IDC_BUTTON8,
              IDC_BUTTON9:
              try
// Ausgabefelder leeren
                SetOutput_(hwnd, param1, param2, param3, '', false);
// Einzelbuttons auswerten und entsprechende Funktion aufrufen
                case LoWord(wParam) of
                  IDC_BUTTON1: OneFunction(param1, param2, param3);
                  IDC_BUTTON2: OneFunction_CDECL(param1, param2, param3);
                  IDC_BUTTON3: OneFunction_STDCALL_(param1, param2, param3);
                  IDC_BUTTON4: OneFunction_as_CDECL(param1, param2, param3);
                  IDC_BUTTON5: OneFunction_CDECL_as_PASCAL(param1, param2, param3);
                  IDC_BUTTON6: OneFunction_STDCALL_as_PASCAL(param1, param2, param3);
                  IDC_BUTTON7: OneFunction_as_STDCALL(param1, param2, param3);
                  IDC_BUTTON8: OneFunction_CDECL_as_STDCALL(param1, param2, param3);
                  IDC_BUTTON9: OneFunction_STDCALL_as_CDECL(param1, param2, param3);
                end;
              except
// Bei einem Ausnahmefehler Meldung ausgeben
                MessageBox(hwnd, exc_text, nil, 0);
              end;
          end;
      end;
  else
    result := false;
  end;
end;

begin
{$IFNDEF STATIC}
// Wenn dynamisch gelinkt, dann:
// Funktionsadressen holen. Bei Fehlschlag Fehlermeldung und Dummy-Adresse setzen.
  GetEntryPoints;
{$ENDIF STATIC}
// Icon laden und, da lokale Variablen in einer Fensterfunktion immer neu
// initialisiert werden, Handle in eine globale Variable schreiben.
  appIcon := LoadIcon(hInstance, MAKEINTRESOURCE(1));
// Dialogbox erstellen und Nachrichtenschleife anschubsen.
  DialogBoxParam(HInstance, MAKEINTRESOURCE(IDD_DIALOG1), 0, @dlgfunc, 0);
end.

